#![allow(deprecated)]
use std::fmt;
use std::str;
/// Dictates how empty range bounds should be handled by the compute node. Defaults to INFINITY.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum UnboundedBehavior {
    #[serde(rename = "INFINITY")]
    Infinity,
    #[serde(rename = "WINDOW_BOUND")]
    WindowBound,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl UnboundedBehavior {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            UnboundedBehavior::Infinity => "INFINITY",
            UnboundedBehavior::WindowBound => "WINDOW_BOUND",
            UnboundedBehavior::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for UnboundedBehavior {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for UnboundedBehavior {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for UnboundedBehavior {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<UnboundedBehavior, conjure_object::plain::ParseEnumError> {
        match v {
            "INFINITY" => Ok(UnboundedBehavior::Infinity),
            "WINDOW_BOUND" => Ok(UnboundedBehavior::WindowBound),
            v => v.parse().map(|v| UnboundedBehavior::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for UnboundedBehavior {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<UnboundedBehavior, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the UnboundedBehavior enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
